<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumento ArrayType
 * Meta informations extracted from the WSDL
 * - type: open:ArrayOfDocumento
 * @subpackage Arrays
 */
class ArrayOfDocumento extends AbstractStructArrayBase
{
    /**
     * The Documento
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\Documento[]
     */
    public $Documento;
    /**
     * Constructor method for ArrayOfDocumento
     * @uses ArrayOfDocumento::setDocumento()
     * @param \StructType\Documento[] $documento
     */
    public function __construct(array $documento = array())
    {
        $this
            ->setDocumento($documento);
    }
    /**
     * Get Documento value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\Documento[]|null
     */
    public function getDocumento()
    {
        return isset($this->Documento) ? $this->Documento : null;
    }
    /**
     * Set Documento value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\Documento[] $documento
     * @return \ArrayType\ArrayOfDocumento
     */
    public function setDocumento(array $documento = array())
    {
        foreach ($documento as $arrayOfDocumentoDocumentoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentoDocumentoItem instanceof \StructType\Documento) {
                throw new \InvalidArgumentException(sprintf('The Documento property can only contain items of \StructType\Documento, "%s" given', is_object($arrayOfDocumentoDocumentoItem) ? get_class($arrayOfDocumentoDocumentoItem) : gettype($arrayOfDocumentoDocumentoItem)), __LINE__);
            }
        }
        if (is_null($documento) || (is_array($documento) && empty($documento))) {
            unset($this->Documento);
        } else {
            $this->Documento = $documento;
        }
        return $this;
    }
    /**
     * Add item to Documento value
     * @throws \InvalidArgumentException
     * @param \StructType\Documento $item
     * @return \ArrayType\ArrayOfDocumento
     */
    public function addToDocumento(\StructType\Documento $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Documento) {
            throw new \InvalidArgumentException(sprintf('The Documento property can only contain items of \StructType\Documento, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Documento[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Documento|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Documento|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Documento|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Documento|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Documento|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Documento
     */
    public function getAttributeName()
    {
        return 'Documento';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumento
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
