<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfDocumentosRetorno ArrayType
 * Meta informations extracted from the WSDL
 * - type: open:ArrayOfDocumentosRetorno
 * @subpackage Arrays
 */
class ArrayOfDocumentosRetorno extends AbstractStructArrayBase
{
    /**
     * The DocumentosRetorno
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\DocumentosRetorno[]
     */
    public $DocumentosRetorno;
    /**
     * Constructor method for ArrayOfDocumentosRetorno
     * @uses ArrayOfDocumentosRetorno::setDocumentosRetorno()
     * @param \StructType\DocumentosRetorno[] $documentosRetorno
     */
    public function __construct(array $documentosRetorno = array())
    {
        $this
            ->setDocumentosRetorno($documentosRetorno);
    }
    /**
     * Get DocumentosRetorno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\DocumentosRetorno[]|null
     */
    public function getDocumentosRetorno()
    {
        return isset($this->DocumentosRetorno) ? $this->DocumentosRetorno : null;
    }
    /**
     * Set DocumentosRetorno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosRetorno[] $documentosRetorno
     * @return \ArrayType\ArrayOfDocumentosRetorno
     */
    public function setDocumentosRetorno(array $documentosRetorno = array())
    {
        foreach ($documentosRetorno as $arrayOfDocumentosRetornoDocumentosRetornoItem) {
            // validation for constraint: itemType
            if (!$arrayOfDocumentosRetornoDocumentosRetornoItem instanceof \StructType\DocumentosRetorno) {
                throw new \InvalidArgumentException(sprintf('The DocumentosRetorno property can only contain items of \StructType\DocumentosRetorno, "%s" given', is_object($arrayOfDocumentosRetornoDocumentosRetornoItem) ? get_class($arrayOfDocumentosRetornoDocumentosRetornoItem) : gettype($arrayOfDocumentosRetornoDocumentosRetornoItem)), __LINE__);
            }
        }
        if (is_null($documentosRetorno) || (is_array($documentosRetorno) && empty($documentosRetorno))) {
            unset($this->DocumentosRetorno);
        } else {
            $this->DocumentosRetorno = $documentosRetorno;
        }
        return $this;
    }
    /**
     * Add item to DocumentosRetorno value
     * @throws \InvalidArgumentException
     * @param \StructType\DocumentosRetorno $item
     * @return \ArrayType\ArrayOfDocumentosRetorno
     */
    public function addToDocumentosRetorno(\StructType\DocumentosRetorno $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\DocumentosRetorno) {
            throw new \InvalidArgumentException(sprintf('The DocumentosRetorno property can only contain items of \StructType\DocumentosRetorno, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->DocumentosRetorno[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\DocumentosRetorno|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\DocumentosRetorno|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\DocumentosRetorno|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\DocumentosRetorno|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\DocumentosRetorno|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string DocumentosRetorno
     */
    public function getAttributeName()
    {
        return 'DocumentosRetorno';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfDocumentosRetorno
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
