<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItemCDIRetorno ArrayType
 * Meta informations extracted from the WSDL
 * - type: open:ArrayOfItemCDIRetorno
 * @subpackage Arrays
 */
class ArrayOfItemCDIRetorno extends AbstractStructArrayBase
{
    /**
     * The ItemCDIRetorno
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItemCDIRetorno[]
     */
    public $ItemCDIRetorno;
    /**
     * Constructor method for ArrayOfItemCDIRetorno
     * @uses ArrayOfItemCDIRetorno::setItemCDIRetorno()
     * @param \StructType\ItemCDIRetorno[] $itemCDIRetorno
     */
    public function __construct(array $itemCDIRetorno = array())
    {
        $this
            ->setItemCDIRetorno($itemCDIRetorno);
    }
    /**
     * Get ItemCDIRetorno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItemCDIRetorno[]|null
     */
    public function getItemCDIRetorno()
    {
        return isset($this->ItemCDIRetorno) ? $this->ItemCDIRetorno : null;
    }
    /**
     * Set ItemCDIRetorno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItemCDIRetorno[] $itemCDIRetorno
     * @return \ArrayType\ArrayOfItemCDIRetorno
     */
    public function setItemCDIRetorno(array $itemCDIRetorno = array())
    {
        foreach ($itemCDIRetorno as $arrayOfItemCDIRetornoItemCDIRetornoItem) {
            // validation for constraint: itemType
            if (!$arrayOfItemCDIRetornoItemCDIRetornoItem instanceof \StructType\ItemCDIRetorno) {
                throw new \InvalidArgumentException(sprintf('The ItemCDIRetorno property can only contain items of \StructType\ItemCDIRetorno, "%s" given', is_object($arrayOfItemCDIRetornoItemCDIRetornoItem) ? get_class($arrayOfItemCDIRetornoItemCDIRetornoItem) : gettype($arrayOfItemCDIRetornoItemCDIRetornoItem)), __LINE__);
            }
        }
        if (is_null($itemCDIRetorno) || (is_array($itemCDIRetorno) && empty($itemCDIRetorno))) {
            unset($this->ItemCDIRetorno);
        } else {
            $this->ItemCDIRetorno = $itemCDIRetorno;
        }
        return $this;
    }
    /**
     * Add item to ItemCDIRetorno value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemCDIRetorno $item
     * @return \ArrayType\ArrayOfItemCDIRetorno
     */
    public function addToItemCDIRetorno(\StructType\ItemCDIRetorno $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItemCDIRetorno) {
            throw new \InvalidArgumentException(sprintf('The ItemCDIRetorno property can only contain items of \StructType\ItemCDIRetorno, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ItemCDIRetorno[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItemCDIRetorno|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItemCDIRetorno|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItemCDIRetorno|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItemCDIRetorno|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItemCDIRetorno|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItemCDIRetorno
     */
    public function getAttributeName()
    {
        return 'ItemCDIRetorno';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfItemCDIRetorno
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
