<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItemPagamentoCDI ArrayType
 * Meta informations extracted from the WSDL
 * - type: open:ArrayOfItemPagamentoCDI
 * @subpackage Arrays
 */
class ArrayOfItemPagamentoCDI extends AbstractStructArrayBase
{
    /**
     * The ItemPagamentoCDI
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItemPagamentoCDI[]
     */
    public $ItemPagamentoCDI;
    /**
     * Constructor method for ArrayOfItemPagamentoCDI
     * @uses ArrayOfItemPagamentoCDI::setItemPagamentoCDI()
     * @param \StructType\ItemPagamentoCDI[] $itemPagamentoCDI
     */
    public function __construct(array $itemPagamentoCDI = array())
    {
        $this
            ->setItemPagamentoCDI($itemPagamentoCDI);
    }
    /**
     * Get ItemPagamentoCDI value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItemPagamentoCDI[]|null
     */
    public function getItemPagamentoCDI()
    {
        return isset($this->ItemPagamentoCDI) ? $this->ItemPagamentoCDI : null;
    }
    /**
     * Set ItemPagamentoCDI value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItemPagamentoCDI[] $itemPagamentoCDI
     * @return \ArrayType\ArrayOfItemPagamentoCDI
     */
    public function setItemPagamentoCDI(array $itemPagamentoCDI = array())
    {
        foreach ($itemPagamentoCDI as $arrayOfItemPagamentoCDIItemPagamentoCDIItem) {
            // validation for constraint: itemType
            if (!$arrayOfItemPagamentoCDIItemPagamentoCDIItem instanceof \StructType\ItemPagamentoCDI) {
                throw new \InvalidArgumentException(sprintf('The ItemPagamentoCDI property can only contain items of \StructType\ItemPagamentoCDI, "%s" given', is_object($arrayOfItemPagamentoCDIItemPagamentoCDIItem) ? get_class($arrayOfItemPagamentoCDIItemPagamentoCDIItem) : gettype($arrayOfItemPagamentoCDIItemPagamentoCDIItem)), __LINE__);
            }
        }
        if (is_null($itemPagamentoCDI) || (is_array($itemPagamentoCDI) && empty($itemPagamentoCDI))) {
            unset($this->ItemPagamentoCDI);
        } else {
            $this->ItemPagamentoCDI = $itemPagamentoCDI;
        }
        return $this;
    }
    /**
     * Add item to ItemPagamentoCDI value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemPagamentoCDI $item
     * @return \ArrayType\ArrayOfItemPagamentoCDI
     */
    public function addToItemPagamentoCDI(\StructType\ItemPagamentoCDI $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItemPagamentoCDI) {
            throw new \InvalidArgumentException(sprintf('The ItemPagamentoCDI property can only contain items of \StructType\ItemPagamentoCDI, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ItemPagamentoCDI[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItemPagamentoCDI|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItemPagamentoCDI|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItemPagamentoCDI|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItemPagamentoCDI|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItemPagamentoCDI|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItemPagamentoCDI
     */
    public function getAttributeName()
    {
        return 'ItemPagamentoCDI';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfItemPagamentoCDI
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
