<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItemPagamentoICMS ArrayType
 * Meta informations extracted from the WSDL
 * - type: open:ArrayOfItemPagamentoICMS
 * @subpackage Arrays
 */
class ArrayOfItemPagamentoICMS extends AbstractStructArrayBase
{
    /**
     * The ItemPagamentoICMS
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItemPagamentoICMS[]
     */
    public $ItemPagamentoICMS;
    /**
     * Constructor method for ArrayOfItemPagamentoICMS
     * @uses ArrayOfItemPagamentoICMS::setItemPagamentoICMS()
     * @param \StructType\ItemPagamentoICMS[] $itemPagamentoICMS
     */
    public function __construct(array $itemPagamentoICMS = array())
    {
        $this
            ->setItemPagamentoICMS($itemPagamentoICMS);
    }
    /**
     * Get ItemPagamentoICMS value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItemPagamentoICMS[]|null
     */
    public function getItemPagamentoICMS()
    {
        return isset($this->ItemPagamentoICMS) ? $this->ItemPagamentoICMS : null;
    }
    /**
     * Set ItemPagamentoICMS value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItemPagamentoICMS[] $itemPagamentoICMS
     * @return \ArrayType\ArrayOfItemPagamentoICMS
     */
    public function setItemPagamentoICMS(array $itemPagamentoICMS = array())
    {
        foreach ($itemPagamentoICMS as $arrayOfItemPagamentoICMSItemPagamentoICMSItem) {
            // validation for constraint: itemType
            if (!$arrayOfItemPagamentoICMSItemPagamentoICMSItem instanceof \StructType\ItemPagamentoICMS) {
                throw new \InvalidArgumentException(sprintf('The ItemPagamentoICMS property can only contain items of \StructType\ItemPagamentoICMS, "%s" given', is_object($arrayOfItemPagamentoICMSItemPagamentoICMSItem) ? get_class($arrayOfItemPagamentoICMSItemPagamentoICMSItem) : gettype($arrayOfItemPagamentoICMSItemPagamentoICMSItem)), __LINE__);
            }
        }
        if (is_null($itemPagamentoICMS) || (is_array($itemPagamentoICMS) && empty($itemPagamentoICMS))) {
            unset($this->ItemPagamentoICMS);
        } else {
            $this->ItemPagamentoICMS = $itemPagamentoICMS;
        }
        return $this;
    }
    /**
     * Add item to ItemPagamentoICMS value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemPagamentoICMS $item
     * @return \ArrayType\ArrayOfItemPagamentoICMS
     */
    public function addToItemPagamentoICMS(\StructType\ItemPagamentoICMS $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItemPagamentoICMS) {
            throw new \InvalidArgumentException(sprintf('The ItemPagamentoICMS property can only contain items of \StructType\ItemPagamentoICMS, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ItemPagamentoICMS[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItemPagamentoICMS|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItemPagamentoICMS|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItemPagamentoICMS|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItemPagamentoICMS|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItemPagamentoICMS|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItemPagamentoICMS
     */
    public function getAttributeName()
    {
        return 'ItemPagamentoICMS';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfItemPagamentoICMS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
