<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfItemPagamentoRetorno ArrayType
 * Meta informations extracted from the WSDL
 * - type: open:ArrayOfItemPagamentoRetorno
 * @subpackage Arrays
 */
class ArrayOfItemPagamentoRetorno extends AbstractStructArrayBase
{
    /**
     * The ItemPagamentoRetorno
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ItemPagamentoRetorno[]
     */
    public $ItemPagamentoRetorno;
    /**
     * Constructor method for ArrayOfItemPagamentoRetorno
     * @uses ArrayOfItemPagamentoRetorno::setItemPagamentoRetorno()
     * @param \StructType\ItemPagamentoRetorno[] $itemPagamentoRetorno
     */
    public function __construct(array $itemPagamentoRetorno = array())
    {
        $this
            ->setItemPagamentoRetorno($itemPagamentoRetorno);
    }
    /**
     * Get ItemPagamentoRetorno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ItemPagamentoRetorno[]|null
     */
    public function getItemPagamentoRetorno()
    {
        return isset($this->ItemPagamentoRetorno) ? $this->ItemPagamentoRetorno : null;
    }
    /**
     * Set ItemPagamentoRetorno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ItemPagamentoRetorno[] $itemPagamentoRetorno
     * @return \ArrayType\ArrayOfItemPagamentoRetorno
     */
    public function setItemPagamentoRetorno(array $itemPagamentoRetorno = array())
    {
        foreach ($itemPagamentoRetorno as $arrayOfItemPagamentoRetornoItemPagamentoRetornoItem) {
            // validation for constraint: itemType
            if (!$arrayOfItemPagamentoRetornoItemPagamentoRetornoItem instanceof \StructType\ItemPagamentoRetorno) {
                throw new \InvalidArgumentException(sprintf('The ItemPagamentoRetorno property can only contain items of \StructType\ItemPagamentoRetorno, "%s" given', is_object($arrayOfItemPagamentoRetornoItemPagamentoRetornoItem) ? get_class($arrayOfItemPagamentoRetornoItemPagamentoRetornoItem) : gettype($arrayOfItemPagamentoRetornoItemPagamentoRetornoItem)), __LINE__);
            }
        }
        if (is_null($itemPagamentoRetorno) || (is_array($itemPagamentoRetorno) && empty($itemPagamentoRetorno))) {
            unset($this->ItemPagamentoRetorno);
        } else {
            $this->ItemPagamentoRetorno = $itemPagamentoRetorno;
        }
        return $this;
    }
    /**
     * Add item to ItemPagamentoRetorno value
     * @throws \InvalidArgumentException
     * @param \StructType\ItemPagamentoRetorno $item
     * @return \ArrayType\ArrayOfItemPagamentoRetorno
     */
    public function addToItemPagamentoRetorno(\StructType\ItemPagamentoRetorno $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ItemPagamentoRetorno) {
            throw new \InvalidArgumentException(sprintf('The ItemPagamentoRetorno property can only contain items of \StructType\ItemPagamentoRetorno, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ItemPagamentoRetorno[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ItemPagamentoRetorno|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ItemPagamentoRetorno|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ItemPagamentoRetorno|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ItemPagamentoRetorno|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ItemPagamentoRetorno|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ItemPagamentoRetorno
     */
    public function getAttributeName()
    {
        return 'ItemPagamentoRetorno';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfItemPagamentoRetorno
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
