<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ConsultaDadosWebService' => '\\StructType\\ConsultaDadosWebService',
            'DocumentosRetorno' => '\\StructType\\DocumentosRetorno',
            'ItemPagamentoRetorno' => '\\StructType\\ItemPagamentoRetorno',
            'DadosContribuintePrincipalRetorno' => '\\StructType\\DadosContribuintePrincipalRetorno',
            'Retorno' => '\\StructType\\Retorno',
            'ArrayOfItemPagamentoRetorno' => '\\ArrayType\\ArrayOfItemPagamentoRetorno',
            'ArrayOfDocumentosRetorno' => '\\ArrayType\\ArrayOfDocumentosRetorno',
            'FalhaSessaoLote' => '\\StructType\\FalhaSessaoLote',
            'ArrayOfFalhaSessaoLote' => '\\ArrayType\\ArrayOfFalhaSessaoLote',
            'ChamadaDadosCDIWebService' => '\\StructType\\ChamadaDadosCDIWebService',
            'ItemCDIRetorno' => '\\StructType\\ItemCDIRetorno',
            'ArrayOfItemCDIRetorno' => '\\ArrayType\\ArrayOfItemCDIRetorno',
            'DocumentoProcEspecial' => '\\StructType\\DocumentoProcEspecial',
            'ItemPagamentoICMS' => '\\StructType\\ItemPagamentoICMS',
            'ArrayOfItemPagamentoICMS' => '\\ArrayType\\ArrayOfItemPagamentoICMS',
            'DocumentoAuto' => '\\StructType\\DocumentoAuto',
            'Documento' => '\\StructType\\Documento',
            'ItemPagamento' => '\\StructType\\ItemPagamento',
            'ArrayOfItemPagamento' => '\\ArrayType\\ArrayOfItemPagamento',
            'DocumentoITD' => '\\StructType\\DocumentoITD',
            'DocumentoCDI' => '\\StructType\\DocumentoCDI',
            'ItemPagamentoCDI' => '\\StructType\\ItemPagamentoCDI',
            'ArrayOfItemPagamentoCDI' => '\\ArrayType\\ArrayOfItemPagamentoCDI',
            'ChamadaDadosPrecatorioWebService' => '\\StructType\\ChamadaDadosPrecatorioWebService',
            'ChamadaDadosDocArrecadacaoWebService' => '\\StructType\\ChamadaDadosDocArrecadacaoWebService',
            'ChamadaDadosProcEspecialWebService' => '\\StructType\\ChamadaDadosProcEspecialWebService',
            'DocumentoPrecatorio' => '\\StructType\\DocumentoPrecatorio',
            'ChamadaDadosWebServiceRefLote' => '\\StructType\\ChamadaDadosWebServiceRefLote',
            'DocumentoParcelamento' => '\\StructType\\DocumentoParcelamento',
            'Emitente' => '\\StructType\\Emitente',
            'ArrayOfDocumento' => '\\ArrayType\\ArrayOfDocumento',
            'enviarDadosAuto' => '\\StructType\\EnviarDadosAuto',
            'enviarDadosAutoResponse' => '\\StructType\\EnviarDadosAutoResponse',
            'enviarDados' => '\\StructType\\EnviarDados',
            'enviarDadosResponse' => '\\StructType\\EnviarDadosResponse',
            'enviarDadosCDI' => '\\StructType\\EnviarDadosCDI',
            'enviarDadosCDIResponse' => '\\StructType\\EnviarDadosCDIResponse',
            'enviarDadosProcEspecial' => '\\StructType\\EnviarDadosProcEspecial',
            'enviarDadosProcEspecialResponse' => '\\StructType\\EnviarDadosProcEspecialResponse',
            'consultarDados' => '\\StructType\\ConsultarDados',
            'consultarDadosResponse' => '\\StructType\\ConsultarDadosResponse',
            'enviarDadosParcelamento' => '\\StructType\\EnviarDadosParcelamento',
            'enviarDadosParcelamentoResponse' => '\\StructType\\EnviarDadosParcelamentoResponse',
            'enviarDadosITD' => '\\StructType\\EnviarDadosITD',
            'enviarDadosITDResponse' => '\\StructType\\EnviarDadosITDResponse',
            'enviarDadosPrecatorio' => '\\StructType\\EnviarDadosPrecatorio',
            'enviarDadosPrecatorioResponse' => '\\StructType\\EnviarDadosPrecatorioResponse',
        );
    }
}
