<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChamadaDadosDocArrecadacaoWebService StructType
 * @subpackage Structs
 */
class ChamadaDadosDocArrecadacaoWebService extends AbstractStructBase
{
    /**
     * The CnpjCpf
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $CnpjCpf;
    /**
     * The CodigoBarras
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $CodigoBarras;
    /**
     * The Retorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var \StructType\Retorno
     */
    public $Retorno;
    /**
     * Constructor method for ChamadaDadosDocArrecadacaoWebService
     * @uses ChamadaDadosDocArrecadacaoWebService::setCnpjCpf()
     * @uses ChamadaDadosDocArrecadacaoWebService::setCodigoBarras()
     * @uses ChamadaDadosDocArrecadacaoWebService::setRetorno()
     * @param string $cnpjCpf
     * @param string $codigoBarras
     * @param \StructType\Retorno $retorno
     */
    public function __construct($cnpjCpf = null, $codigoBarras = null, \StructType\Retorno $retorno = null)
    {
        $this
            ->setCnpjCpf($cnpjCpf)
            ->setCodigoBarras($codigoBarras)
            ->setRetorno($retorno);
    }
    /**
     * Get CnpjCpf value
     * @return string
     */
    public function getCnpjCpf()
    {
        return $this->CnpjCpf;
    }
    /**
     * Set CnpjCpf value
     * @param string $cnpjCpf
     * @return \StructType\ChamadaDadosDocArrecadacaoWebService
     */
    public function setCnpjCpf($cnpjCpf = null)
    {
        // validation for constraint: string
        if (!is_null($cnpjCpf) && !is_string($cnpjCpf)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cnpjCpf)), __LINE__);
        }
        $this->CnpjCpf = $cnpjCpf;
        return $this;
    }
    /**
     * Get CodigoBarras value
     * @return string
     */
    public function getCodigoBarras()
    {
        return $this->CodigoBarras;
    }
    /**
     * Set CodigoBarras value
     * @param string $codigoBarras
     * @return \StructType\ChamadaDadosDocArrecadacaoWebService
     */
    public function setCodigoBarras($codigoBarras = null)
    {
        // validation for constraint: string
        if (!is_null($codigoBarras) && !is_string($codigoBarras)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($codigoBarras)), __LINE__);
        }
        $this->CodigoBarras = $codigoBarras;
        return $this;
    }
    /**
     * Get Retorno value
     * @return \StructType\Retorno
     */
    public function getRetorno()
    {
        return $this->Retorno;
    }
    /**
     * Set Retorno value
     * @param \StructType\Retorno $retorno
     * @return \StructType\ChamadaDadosDocArrecadacaoWebService
     */
    public function setRetorno(\StructType\Retorno $retorno = null)
    {
        $this->Retorno = $retorno;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChamadaDadosDocArrecadacaoWebService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
