<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ChamadaDadosWebServiceRefLote StructType
 * @subpackage Structs
 */
class ChamadaDadosWebServiceRefLote extends AbstractStructBase
{
    /**
     * The CNPJCPF
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $CNPJCPF;
    /**
     * The DataRecebimento
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DataRecebimento;
    /**
     * The IdSessao
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $IdSessao;
    /**
     * The Retorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var \StructType\Retorno
     */
    public $Retorno;
    /**
     * Constructor method for ChamadaDadosWebServiceRefLote
     * @uses ChamadaDadosWebServiceRefLote::setCNPJCPF()
     * @uses ChamadaDadosWebServiceRefLote::setDataRecebimento()
     * @uses ChamadaDadosWebServiceRefLote::setIdSessao()
     * @uses ChamadaDadosWebServiceRefLote::setRetorno()
     * @param int $cNPJCPF
     * @param string $dataRecebimento
     * @param string $idSessao
     * @param \StructType\Retorno $retorno
     */
    public function __construct($cNPJCPF = null, $dataRecebimento = null, $idSessao = null, \StructType\Retorno $retorno = null)
    {
        $this
            ->setCNPJCPF($cNPJCPF)
            ->setDataRecebimento($dataRecebimento)
            ->setIdSessao($idSessao)
            ->setRetorno($retorno);
    }
    /**
     * Get CNPJCPF value
     * @return int
     */
    public function getCNPJCPF()
    {
        return $this->CNPJCPF;
    }
    /**
     * Set CNPJCPF value
     * @param int $cNPJCPF
     * @return \StructType\ChamadaDadosWebServiceRefLote
     */
    public function setCNPJCPF($cNPJCPF = null)
    {
        // validation for constraint: int
        if (!is_null($cNPJCPF) && !is_numeric($cNPJCPF)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($cNPJCPF)), __LINE__);
        }
        $this->CNPJCPF = $cNPJCPF;
        return $this;
    }
    /**
     * Get DataRecebimento value
     * @return string
     */
    public function getDataRecebimento()
    {
        return $this->DataRecebimento;
    }
    /**
     * Set DataRecebimento value
     * @param string $dataRecebimento
     * @return \StructType\ChamadaDadosWebServiceRefLote
     */
    public function setDataRecebimento($dataRecebimento = null)
    {
        // validation for constraint: string
        if (!is_null($dataRecebimento) && !is_string($dataRecebimento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dataRecebimento)), __LINE__);
        }
        $this->DataRecebimento = $dataRecebimento;
        return $this;
    }
    /**
     * Get IdSessao value
     * @return string
     */
    public function getIdSessao()
    {
        return $this->IdSessao;
    }
    /**
     * Set IdSessao value
     * @param string $idSessao
     * @return \StructType\ChamadaDadosWebServiceRefLote
     */
    public function setIdSessao($idSessao = null)
    {
        // validation for constraint: string
        if (!is_null($idSessao) && !is_string($idSessao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idSessao)), __LINE__);
        }
        $this->IdSessao = $idSessao;
        return $this;
    }
    /**
     * Get Retorno value
     * @return \StructType\Retorno
     */
    public function getRetorno()
    {
        return $this->Retorno;
    }
    /**
     * Set Retorno value
     * @param \StructType\Retorno $retorno
     * @return \StructType\ChamadaDadosWebServiceRefLote
     */
    public function setRetorno(\StructType\Retorno $retorno = null)
    {
        $this->Retorno = $retorno;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ChamadaDadosWebServiceRefLote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
