<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConsultaDadosWebService StructType
 * @subpackage Structs
 */
class ConsultaDadosWebService extends AbstractStructBase
{
    /**
     * The IdSessao
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $IdSessao;
    /**
     * The Retorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var \StructType\Retorno
     */
    public $Retorno;
    /**
     * The Status
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $Status;
    /**
     * The DocsRetorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfDocumentosRetorno
     */
    public $DocsRetorno;
    /**
     * The ListaFalha
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var \ArrayType\ArrayOfFalhaSessaoLote
     */
    public $ListaFalha;
    /**
     * Constructor method for ConsultaDadosWebService
     * @uses ConsultaDadosWebService::setIdSessao()
     * @uses ConsultaDadosWebService::setRetorno()
     * @uses ConsultaDadosWebService::setStatus()
     * @uses ConsultaDadosWebService::setDocsRetorno()
     * @uses ConsultaDadosWebService::setListaFalha()
     * @param string $idSessao
     * @param \StructType\Retorno $retorno
     * @param string $status
     * @param \ArrayType\ArrayOfDocumentosRetorno $docsRetorno
     * @param \ArrayType\ArrayOfFalhaSessaoLote $listaFalha
     */
    public function __construct($idSessao = null, \StructType\Retorno $retorno = null, $status = null, \ArrayType\ArrayOfDocumentosRetorno $docsRetorno = null, \ArrayType\ArrayOfFalhaSessaoLote $listaFalha = null)
    {
        $this
            ->setIdSessao($idSessao)
            ->setRetorno($retorno)
            ->setStatus($status)
            ->setDocsRetorno($docsRetorno)
            ->setListaFalha($listaFalha);
    }
    /**
     * Get IdSessao value
     * @return string
     */
    public function getIdSessao()
    {
        return $this->IdSessao;
    }
    /**
     * Set IdSessao value
     * @param string $idSessao
     * @return \StructType\ConsultaDadosWebService
     */
    public function setIdSessao($idSessao = null)
    {
        // validation for constraint: string
        if (!is_null($idSessao) && !is_string($idSessao)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idSessao)), __LINE__);
        }
        $this->IdSessao = $idSessao;
        return $this;
    }
    /**
     * Get Retorno value
     * @return \StructType\Retorno
     */
    public function getRetorno()
    {
        return $this->Retorno;
    }
    /**
     * Set Retorno value
     * @param \StructType\Retorno $retorno
     * @return \StructType\ConsultaDadosWebService
     */
    public function setRetorno(\StructType\Retorno $retorno = null)
    {
        $this->Retorno = $retorno;
        return $this;
    }
    /**
     * Get Status value
     * @return string
     */
    public function getStatus()
    {
        return $this->Status;
    }
    /**
     * Set Status value
     * @param string $status
     * @return \StructType\ConsultaDadosWebService
     */
    public function setStatus($status = null)
    {
        // validation for constraint: string
        if (!is_null($status) && !is_string($status)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($status)), __LINE__);
        }
        $this->Status = $status;
        return $this;
    }
    /**
     * Get DocsRetorno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfDocumentosRetorno|null
     */
    public function getDocsRetorno()
    {
        return isset($this->DocsRetorno) ? $this->DocsRetorno : null;
    }
    /**
     * Set DocsRetorno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfDocumentosRetorno $docsRetorno
     * @return \StructType\ConsultaDadosWebService
     */
    public function setDocsRetorno(\ArrayType\ArrayOfDocumentosRetorno $docsRetorno = null)
    {
        if (is_null($docsRetorno) || (is_array($docsRetorno) && empty($docsRetorno))) {
            unset($this->DocsRetorno);
        } else {
            $this->DocsRetorno = $docsRetorno;
        }
        return $this;
    }
    /**
     * Get ListaFalha value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \ArrayType\ArrayOfFalhaSessaoLote|null
     */
    public function getListaFalha()
    {
        return isset($this->ListaFalha) ? $this->ListaFalha : null;
    }
    /**
     * Set ListaFalha value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \ArrayType\ArrayOfFalhaSessaoLote $listaFalha
     * @return \StructType\ConsultaDadosWebService
     */
    public function setListaFalha(\ArrayType\ArrayOfFalhaSessaoLote $listaFalha = null)
    {
        if (is_null($listaFalha) || (is_array($listaFalha) && empty($listaFalha))) {
            unset($this->ListaFalha);
        } else {
            $this->ListaFalha = $listaFalha;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConsultaDadosWebService
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
