<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for FalhaSessaoLote StructType
 * @subpackage Structs
 */
class FalhaSessaoLote extends AbstractStructBase
{
    /**
     * The CoErro
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $CoErro;
    /**
     * The DescricaoErro
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DescricaoErro;
    /**
     * The NuIdentificador
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $NuIdentificador;
    /**
     * Constructor method for FalhaSessaoLote
     * @uses FalhaSessaoLote::setCoErro()
     * @uses FalhaSessaoLote::setDescricaoErro()
     * @uses FalhaSessaoLote::setNuIdentificador()
     * @param int $coErro
     * @param string $descricaoErro
     * @param string $nuIdentificador
     */
    public function __construct($coErro = null, $descricaoErro = null, $nuIdentificador = null)
    {
        $this
            ->setCoErro($coErro)
            ->setDescricaoErro($descricaoErro)
            ->setNuIdentificador($nuIdentificador);
    }
    /**
     * Get CoErro value
     * @return int
     */
    public function getCoErro()
    {
        return $this->CoErro;
    }
    /**
     * Set CoErro value
     * @param int $coErro
     * @return \StructType\FalhaSessaoLote
     */
    public function setCoErro($coErro = null)
    {
        // validation for constraint: int
        if (!is_null($coErro) && !is_numeric($coErro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($coErro)), __LINE__);
        }
        $this->CoErro = $coErro;
        return $this;
    }
    /**
     * Get DescricaoErro value
     * @return string
     */
    public function getDescricaoErro()
    {
        return $this->DescricaoErro;
    }
    /**
     * Set DescricaoErro value
     * @param string $descricaoErro
     * @return \StructType\FalhaSessaoLote
     */
    public function setDescricaoErro($descricaoErro = null)
    {
        // validation for constraint: string
        if (!is_null($descricaoErro) && !is_string($descricaoErro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($descricaoErro)), __LINE__);
        }
        $this->DescricaoErro = $descricaoErro;
        return $this;
    }
    /**
     * Get NuIdentificador value
     * @return string
     */
    public function getNuIdentificador()
    {
        return $this->NuIdentificador;
    }
    /**
     * Set NuIdentificador value
     * @param string $nuIdentificador
     * @return \StructType\FalhaSessaoLote
     */
    public function setNuIdentificador($nuIdentificador = null)
    {
        // validation for constraint: string
        if (!is_null($nuIdentificador) && !is_string($nuIdentificador)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nuIdentificador)), __LINE__);
        }
        $this->NuIdentificador = $nuIdentificador;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\FalhaSessaoLote
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
