<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemPagamentoICMS StructType
 * @subpackage Structs
 */
class ItemPagamentoICMS extends AbstractStructBase
{
    /**
     * The AnoReferencia
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $AnoReferencia;
    /**
     * The DataVencimento
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $DataVencimento;
    /**
     * The MesReferencia
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $MesReferencia;
    /**
     * The ValorFECP
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECP;
    /**
     * The ValorFECPAtualizado
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPAtualizado;
    /**
     * The ValorFECPMora
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPMora;
    /**
     * The ValorFECPMultaMora
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPMultaMora;
    /**
     * The ValorICMS
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMS;
    /**
     * The ValorICMSAtualizado
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSAtualizado;
    /**
     * The ValorICMSMora
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSMora;
    /**
     * The ValorICMSMultaMora
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSMultaMora;
    /**
     * Constructor method for ItemPagamentoICMS
     * @uses ItemPagamentoICMS::setAnoReferencia()
     * @uses ItemPagamentoICMS::setDataVencimento()
     * @uses ItemPagamentoICMS::setMesReferencia()
     * @uses ItemPagamentoICMS::setValorFECP()
     * @uses ItemPagamentoICMS::setValorFECPAtualizado()
     * @uses ItemPagamentoICMS::setValorFECPMora()
     * @uses ItemPagamentoICMS::setValorFECPMultaMora()
     * @uses ItemPagamentoICMS::setValorICMS()
     * @uses ItemPagamentoICMS::setValorICMSAtualizado()
     * @uses ItemPagamentoICMS::setValorICMSMora()
     * @uses ItemPagamentoICMS::setValorICMSMultaMora()
     * @param int $anoReferencia
     * @param string $dataVencimento
     * @param int $mesReferencia
     * @param float $valorFECP
     * @param float $valorFECPAtualizado
     * @param float $valorFECPMora
     * @param float $valorFECPMultaMora
     * @param float $valorICMS
     * @param float $valorICMSAtualizado
     * @param float $valorICMSMora
     * @param float $valorICMSMultaMora
     */
    public function __construct($anoReferencia = null, $dataVencimento = null, $mesReferencia = null, $valorFECP = null, $valorFECPAtualizado = null, $valorFECPMora = null, $valorFECPMultaMora = null, $valorICMS = null, $valorICMSAtualizado = null, $valorICMSMora = null, $valorICMSMultaMora = null)
    {
        $this
            ->setAnoReferencia($anoReferencia)
            ->setDataVencimento($dataVencimento)
            ->setMesReferencia($mesReferencia)
            ->setValorFECP($valorFECP)
            ->setValorFECPAtualizado($valorFECPAtualizado)
            ->setValorFECPMora($valorFECPMora)
            ->setValorFECPMultaMora($valorFECPMultaMora)
            ->setValorICMS($valorICMS)
            ->setValorICMSAtualizado($valorICMSAtualizado)
            ->setValorICMSMora($valorICMSMora)
            ->setValorICMSMultaMora($valorICMSMultaMora);
    }
    /**
     * Get AnoReferencia value
     * @return int
     */
    public function getAnoReferencia()
    {
        return $this->AnoReferencia;
    }
    /**
     * Set AnoReferencia value
     * @param int $anoReferencia
     * @return \StructType\ItemPagamentoICMS
     */
    public function setAnoReferencia($anoReferencia = null)
    {
        // validation for constraint: int
        if (!is_null($anoReferencia) && !is_numeric($anoReferencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($anoReferencia)), __LINE__);
        }
        $this->AnoReferencia = $anoReferencia;
        return $this;
    }
    /**
     * Get DataVencimento value
     * @return string
     */
    public function getDataVencimento()
    {
        return $this->DataVencimento;
    }
    /**
     * Set DataVencimento value
     * @param string $dataVencimento
     * @return \StructType\ItemPagamentoICMS
     */
    public function setDataVencimento($dataVencimento = null)
    {
        // validation for constraint: string
        if (!is_null($dataVencimento) && !is_string($dataVencimento)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dataVencimento)), __LINE__);
        }
        $this->DataVencimento = $dataVencimento;
        return $this;
    }
    /**
     * Get MesReferencia value
     * @return int
     */
    public function getMesReferencia()
    {
        return $this->MesReferencia;
    }
    /**
     * Set MesReferencia value
     * @param int $mesReferencia
     * @return \StructType\ItemPagamentoICMS
     */
    public function setMesReferencia($mesReferencia = null)
    {
        // validation for constraint: int
        if (!is_null($mesReferencia) && !is_numeric($mesReferencia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($mesReferencia)), __LINE__);
        }
        $this->MesReferencia = $mesReferencia;
        return $this;
    }
    /**
     * Get ValorFECP value
     * @return float
     */
    public function getValorFECP()
    {
        return $this->ValorFECP;
    }
    /**
     * Set ValorFECP value
     * @param float $valorFECP
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorFECP($valorFECP = null)
    {
        $this->ValorFECP = $valorFECP;
        return $this;
    }
    /**
     * Get ValorFECPAtualizado value
     * @return float
     */
    public function getValorFECPAtualizado()
    {
        return $this->ValorFECPAtualizado;
    }
    /**
     * Set ValorFECPAtualizado value
     * @param float $valorFECPAtualizado
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorFECPAtualizado($valorFECPAtualizado = null)
    {
        $this->ValorFECPAtualizado = $valorFECPAtualizado;
        return $this;
    }
    /**
     * Get ValorFECPMora value
     * @return float
     */
    public function getValorFECPMora()
    {
        return $this->ValorFECPMora;
    }
    /**
     * Set ValorFECPMora value
     * @param float $valorFECPMora
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorFECPMora($valorFECPMora = null)
    {
        $this->ValorFECPMora = $valorFECPMora;
        return $this;
    }
    /**
     * Get ValorFECPMultaMora value
     * @return float
     */
    public function getValorFECPMultaMora()
    {
        return $this->ValorFECPMultaMora;
    }
    /**
     * Set ValorFECPMultaMora value
     * @param float $valorFECPMultaMora
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorFECPMultaMora($valorFECPMultaMora = null)
    {
        $this->ValorFECPMultaMora = $valorFECPMultaMora;
        return $this;
    }
    /**
     * Get ValorICMS value
     * @return float
     */
    public function getValorICMS()
    {
        return $this->ValorICMS;
    }
    /**
     * Set ValorICMS value
     * @param float $valorICMS
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorICMS($valorICMS = null)
    {
        $this->ValorICMS = $valorICMS;
        return $this;
    }
    /**
     * Get ValorICMSAtualizado value
     * @return float
     */
    public function getValorICMSAtualizado()
    {
        return $this->ValorICMSAtualizado;
    }
    /**
     * Set ValorICMSAtualizado value
     * @param float $valorICMSAtualizado
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorICMSAtualizado($valorICMSAtualizado = null)
    {
        $this->ValorICMSAtualizado = $valorICMSAtualizado;
        return $this;
    }
    /**
     * Get ValorICMSMora value
     * @return float
     */
    public function getValorICMSMora()
    {
        return $this->ValorICMSMora;
    }
    /**
     * Set ValorICMSMora value
     * @param float $valorICMSMora
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorICMSMora($valorICMSMora = null)
    {
        $this->ValorICMSMora = $valorICMSMora;
        return $this;
    }
    /**
     * Get ValorICMSMultaMora value
     * @return float
     */
    public function getValorICMSMultaMora()
    {
        return $this->ValorICMSMultaMora;
    }
    /**
     * Set ValorICMSMultaMora value
     * @param float $valorICMSMultaMora
     * @return \StructType\ItemPagamentoICMS
     */
    public function setValorICMSMultaMora($valorICMSMultaMora = null)
    {
        $this->ValorICMSMultaMora = $valorICMSMultaMora;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ItemPagamentoICMS
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
