<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ItemPagamentoRetorno StructType
 * @subpackage Structs
 */
class ItemPagamentoRetorno extends AbstractStructBase
{
    /**
     * The NumControleContribuinte
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $NumControleContribuinte;
    /**
     * The PrincipalRetorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var \StructType\DadosContribuintePrincipalRetorno
     */
    public $PrincipalRetorno;
    /**
     * The Retorno
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var \StructType\Retorno
     */
    public $Retorno;
    /**
     * The ValorFECPMora
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPMora;
    /**
     * The ValorFECPMulta
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPMulta;
    /**
     * The ValorFECPPrincipal
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPPrincipal;
    /**
     * The ValorFECPTotal
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorFECPTotal;
    /**
     * The ValorICMSMora
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSMora;
    /**
     * The ValorICMSMulta
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSMulta;
    /**
     * The ValorICMSPrincipal
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSPrincipal;
    /**
     * The ValorICMSTotal
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorICMSTotal;
    /**
     * The ValorTotal
     * Meta informations extracted from the WSDL
     * - minOccurs: 1
     * - nillable: true
     * @var float
     */
    public $ValorTotal;
    /**
     * Constructor method for ItemPagamentoRetorno
     * @uses ItemPagamentoRetorno::setNumControleContribuinte()
     * @uses ItemPagamentoRetorno::setPrincipalRetorno()
     * @uses ItemPagamentoRetorno::setRetorno()
     * @uses ItemPagamentoRetorno::setValorFECPMora()
     * @uses ItemPagamentoRetorno::setValorFECPMulta()
     * @uses ItemPagamentoRetorno::setValorFECPPrincipal()
     * @uses ItemPagamentoRetorno::setValorFECPTotal()
     * @uses ItemPagamentoRetorno::setValorICMSMora()
     * @uses ItemPagamentoRetorno::setValorICMSMulta()
     * @uses ItemPagamentoRetorno::setValorICMSPrincipal()
     * @uses ItemPagamentoRetorno::setValorICMSTotal()
     * @uses ItemPagamentoRetorno::setValorTotal()
     * @param string $numControleContribuinte
     * @param \StructType\DadosContribuintePrincipalRetorno $principalRetorno
     * @param \StructType\Retorno $retorno
     * @param float $valorFECPMora
     * @param float $valorFECPMulta
     * @param float $valorFECPPrincipal
     * @param float $valorFECPTotal
     * @param float $valorICMSMora
     * @param float $valorICMSMulta
     * @param float $valorICMSPrincipal
     * @param float $valorICMSTotal
     * @param float $valorTotal
     */
    public function __construct($numControleContribuinte = null, \StructType\DadosContribuintePrincipalRetorno $principalRetorno = null, \StructType\Retorno $retorno = null, $valorFECPMora = null, $valorFECPMulta = null, $valorFECPPrincipal = null, $valorFECPTotal = null, $valorICMSMora = null, $valorICMSMulta = null, $valorICMSPrincipal = null, $valorICMSTotal = null, $valorTotal = null)
    {
        $this
            ->setNumControleContribuinte($numControleContribuinte)
            ->setPrincipalRetorno($principalRetorno)
            ->setRetorno($retorno)
            ->setValorFECPMora($valorFECPMora)
            ->setValorFECPMulta($valorFECPMulta)
            ->setValorFECPPrincipal($valorFECPPrincipal)
            ->setValorFECPTotal($valorFECPTotal)
            ->setValorICMSMora($valorICMSMora)
            ->setValorICMSMulta($valorICMSMulta)
            ->setValorICMSPrincipal($valorICMSPrincipal)
            ->setValorICMSTotal($valorICMSTotal)
            ->setValorTotal($valorTotal);
    }
    /**
     * Get NumControleContribuinte value
     * @return string
     */
    public function getNumControleContribuinte()
    {
        return $this->NumControleContribuinte;
    }
    /**
     * Set NumControleContribuinte value
     * @param string $numControleContribuinte
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setNumControleContribuinte($numControleContribuinte = null)
    {
        // validation for constraint: string
        if (!is_null($numControleContribuinte) && !is_string($numControleContribuinte)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($numControleContribuinte)), __LINE__);
        }
        $this->NumControleContribuinte = $numControleContribuinte;
        return $this;
    }
    /**
     * Get PrincipalRetorno value
     * @return \StructType\DadosContribuintePrincipalRetorno
     */
    public function getPrincipalRetorno()
    {
        return $this->PrincipalRetorno;
    }
    /**
     * Set PrincipalRetorno value
     * @param \StructType\DadosContribuintePrincipalRetorno $principalRetorno
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setPrincipalRetorno(\StructType\DadosContribuintePrincipalRetorno $principalRetorno = null)
    {
        $this->PrincipalRetorno = $principalRetorno;
        return $this;
    }
    /**
     * Get Retorno value
     * @return \StructType\Retorno
     */
    public function getRetorno()
    {
        return $this->Retorno;
    }
    /**
     * Set Retorno value
     * @param \StructType\Retorno $retorno
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setRetorno(\StructType\Retorno $retorno = null)
    {
        $this->Retorno = $retorno;
        return $this;
    }
    /**
     * Get ValorFECPMora value
     * @return float
     */
    public function getValorFECPMora()
    {
        return $this->ValorFECPMora;
    }
    /**
     * Set ValorFECPMora value
     * @param float $valorFECPMora
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorFECPMora($valorFECPMora = null)
    {
        $this->ValorFECPMora = $valorFECPMora;
        return $this;
    }
    /**
     * Get ValorFECPMulta value
     * @return float
     */
    public function getValorFECPMulta()
    {
        return $this->ValorFECPMulta;
    }
    /**
     * Set ValorFECPMulta value
     * @param float $valorFECPMulta
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorFECPMulta($valorFECPMulta = null)
    {
        $this->ValorFECPMulta = $valorFECPMulta;
        return $this;
    }
    /**
     * Get ValorFECPPrincipal value
     * @return float
     */
    public function getValorFECPPrincipal()
    {
        return $this->ValorFECPPrincipal;
    }
    /**
     * Set ValorFECPPrincipal value
     * @param float $valorFECPPrincipal
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorFECPPrincipal($valorFECPPrincipal = null)
    {
        $this->ValorFECPPrincipal = $valorFECPPrincipal;
        return $this;
    }
    /**
     * Get ValorFECPTotal value
     * @return float
     */
    public function getValorFECPTotal()
    {
        return $this->ValorFECPTotal;
    }
    /**
     * Set ValorFECPTotal value
     * @param float $valorFECPTotal
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorFECPTotal($valorFECPTotal = null)
    {
        $this->ValorFECPTotal = $valorFECPTotal;
        return $this;
    }
    /**
     * Get ValorICMSMora value
     * @return float
     */
    public function getValorICMSMora()
    {
        return $this->ValorICMSMora;
    }
    /**
     * Set ValorICMSMora value
     * @param float $valorICMSMora
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorICMSMora($valorICMSMora = null)
    {
        $this->ValorICMSMora = $valorICMSMora;
        return $this;
    }
    /**
     * Get ValorICMSMulta value
     * @return float
     */
    public function getValorICMSMulta()
    {
        return $this->ValorICMSMulta;
    }
    /**
     * Set ValorICMSMulta value
     * @param float $valorICMSMulta
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorICMSMulta($valorICMSMulta = null)
    {
        $this->ValorICMSMulta = $valorICMSMulta;
        return $this;
    }
    /**
     * Get ValorICMSPrincipal value
     * @return float
     */
    public function getValorICMSPrincipal()
    {
        return $this->ValorICMSPrincipal;
    }
    /**
     * Set ValorICMSPrincipal value
     * @param float $valorICMSPrincipal
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorICMSPrincipal($valorICMSPrincipal = null)
    {
        $this->ValorICMSPrincipal = $valorICMSPrincipal;
        return $this;
    }
    /**
     * Get ValorICMSTotal value
     * @return float
     */
    public function getValorICMSTotal()
    {
        return $this->ValorICMSTotal;
    }
    /**
     * Set ValorICMSTotal value
     * @param float $valorICMSTotal
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorICMSTotal($valorICMSTotal = null)
    {
        $this->ValorICMSTotal = $valorICMSTotal;
        return $this;
    }
    /**
     * Get ValorTotal value
     * @return float
     */
    public function getValorTotal()
    {
        return $this->ValorTotal;
    }
    /**
     * Set ValorTotal value
     * @param float $valorTotal
     * @return \StructType\ItemPagamentoRetorno
     */
    public function setValorTotal($valorTotal = null)
    {
        $this->ValorTotal = $valorTotal;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ItemPagamentoRetorno
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
